#pragma once
#include "Leadwerks.h"
#include "Level.h"
#include "MenuManager.h"
#include "HUD.h"

using namespace Leadwerks;

class App
{
public:
	//Window
	Window* window;
	Context* context;

	//Menu
	MenuManager* menu;

	//HUD
	HUD* hud;

	//Level
	World* world;
	Map* map;
	Camera* camera;
	Level* level;

	App();
	virtual ~App();
	
    virtual bool Start();
    virtual bool Loop();

	void CreateCamera();
};
