//Must-have
#include "Ball.h"

//Using
#include "Teleport.h"
#include "Score.h"

//Debug
#include <iostream>
using namespace std;

Ball::Ball(float X, float Y, float Z, Vec3 color, int objID, vector<LevelObject*> *levelobjects){
	SetModel( Model::Load("Models/sphere.mdl") );
	GetModel()->SetPosition(X, Y, Z);
	//mdl->SetScale(2, 2, 2);
	GetModel()->SetMass(.1f);
	GetModel()->SetColor(color.x, color.y, color.z);
	GetModel()->SetPhysicsMode(Entity::RigidBodyPhysics);
	GetModel()->SetShape(Shape::Sphere(0,0,0, 0,0,0, 15, 15, 15));
	GetModel()->SetSweptCollisionMode(true);
	//mdl->SetColor(1.0f, 1.0f, 0.0f);
	GetModel()->SetOcclusionCullingMode(true);
	//mdl->Release();
	//mdl->Release();
	cout << "Ball created ---------------------" << endl;

	SetObjectType(2);
	stringstream s;
	s << objID;
	GetModel()->SetKeyValue("name", s.str());

	startPos = GetModel()->GetPosition();

	objects = levelobjects;
	SetActive(true);
}

Ball::~Ball(){

}

void Ball::Update(){
	for (int i = 0; i < objects->size(); i++){

		if (!objects->at(i)->GetActive()) continue;

		//Jump pad
		if (objects->at(i)->GetObjectType() == 3){
			if (GetModel()->GetDistanceToEntity(objects->at(i)->GetModel()) < 2){
				GetModel()->AddForce(0, 20*Time::GetSpeed(), 0);
			}
		}

		//Score
		else if (objects->at(i)->GetObjectType() == 4){
			if (GetModel()->GetDistanceToEntity(objects->at(i)->GetModel()) < 1.5f){
				Score* s = (Score*) objects->at(i);
				s->Remove();
			}
		}

		//Teleport
		else if (objects->at(i)->GetObjectType() == 5){
			if (GetModel()->GetDistanceToEntity(objects->at(i)->GetModel()) < 1.5f){
				GetModel()->SetVelocity(Vec3(0,0,0));
				Teleport* tp = (Teleport*) objects->at(i);
				
				GetModel()->SetPosition(tp->GetGotoPos().x, tp->GetGotoPos().y, GetModel()->GetPosition().z);
			}
		}
	}

	if (GetModel()->GetPosition().y < -25.0f){
		Vec3 pos = GetModel()->GetPosition();
		pos.y = 20.0f;
		GetModel()->SetPosition(pos);
	}
}

void Ball::MoveToStartPos(){
	GetModel()->SetPosition(startPos);
}