#pragma once

#include "Leadwerks.h"
#include "Level.h"

using namespace Leadwerks;

class HUD{
private:
	Window* window;
	Context* context;
	Camera* camera;
	Level* level;

	Texture* youWin;
	Texture* pointsCollected;
	Texture* canInteract;
	Texture* canNotInteract;

	Texture* StepCompleted;
	Texture* Step1Unlocked;

	Texture* Step2Unlocked;
	Texture* Step2Locked;

	bool showedPointsFeedback, isIngame, wonGame;
	float feedbackAlpha;
	int curStep;

public:
	HUD(Window* window, Context* context, Camera* camera, Level* level);
	~HUD();

	bool PointsCollected();
	bool BallsAreDown();
	void SetIngame( bool val );
	void Draw();
	void ChangeCamera(Camera* camera);
};