//Main component
#include "Level.h"

//Objects we're using
#include "Flip.h"
#include "Ball.h"
#include "JumpPad.h"
#include "Teleport.h"
#include "Score.h"

Level::Level(){
	objects.resize(0);
};

void Level::CreateLevel(int index){
	switch (index){

		//Menu/splash
		case 0:
			//Balls
			objects.push_back( new Ball(4.0f, 14.5f, -2.0f, Vec3(1, .5f, .5f), objects.size()+10, &objects) );
			objects.push_back( new Ball(-21.25f, 14.5f, -2.0f, Vec3(.5f, 1, .5f), objects.size()+10, &objects) );
			objects.push_back( new Ball(22.75f, 14.5f, -2.0f, Vec3(.5f, .5f, 1), objects.size()+10, &objects) );
			objects.push_back( new Ball(12.75f, 14.5f, -2.0f, Vec3(.5f, .125, 1), objects.size()+10, &objects) );
			objects.push_back( new Ball(-12.75f, 14.5f, -2.0f, Vec3(1, .5f, .125f), objects.size()+10, &objects) );

			//Teleport
			objects.push_back( new Teleport(13.5f, -14.75f, -1.875f, objects.size()+10, -15.75f, 0.0f) );

			//Jump pads
			objects.push_back( new JumpPad(-2.75f, -12.75f, -1.875f, objects.size()+10) );
		break;

		//Level 1
		case 1: 
			//Flip flops
			objects.push_back( new Flip(-15.25f, 15.0f, -1.875f, false, objects.size()+10) );
			objects.push_back( new Flip(-1.75f, 15.0f, -1.875f, false, objects.size()+10) );
			objects.push_back( new Flip(11.75f, 15.0f, -1.875f, false, objects.size()+10) );
			objects.push_back( new Flip(24.0f, 15.0f, -1.875f, false, objects.size()+10) );
			objects.push_back( new Flip(9.0f, -0.75f, -1.875f, false, objects.size()+10) );
			objects.push_back( new Flip(-20.0f, -8.5f, -1.875f, false, objects.size()+10) );
			objects.push_back( new Flip(-18.5f, 11.0f, -1.875f, false, objects.size()+10) );

			//Balls
			objects.push_back( new Ball(-18.75f, 18.25f, -2.0f, Vec3(1, .5f, .5f), objects.size()+10, &objects) );
			objects.push_back( new Ball(-5.0f, 17.75f, -2.0f, Vec3(1, .25f, .25f), objects.size()+10, &objects) );
			objects.push_back( new Ball(7.25, 17.75f, -2.0f, Vec3(.25f, 1, .25f), objects.size()+10, &objects) );
			objects.push_back( new Ball(19.5f, 17.75f, -2.0f, Vec3(.25f, .25f, 1), objects.size()+10, &objects) );

			//Jump pads
			objects.push_back( new JumpPad(24.375f, -2.125f, -1.875f, objects.size()+10) );
			objects.push_back( new JumpPad(-10.625f, -8.125f, -1.875f, objects.size()+10) );
			objects.push_back( new JumpPad(24.375f, -10.875f, -1.875f, objects.size()+10) );

			//Teleports
			objects.push_back( new Teleport(-10.625f, -11.375f, -1.875f, objects.size()+10, 2.375f, 9.125f) );

			//Score points
			objects.push_back( new Score(-8.375f, -3.125f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(-21.375f, 12.875f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(15.625f, -2.875f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(24.375f, 6.625f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(24.125f, -4.625f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(0.625f, 5.875f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(-12.625f, 5.875f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(-6.875f, -12.625f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(3.625f, -3.125f, -1.875f, objects.size()+10) );
		break;

		//Level 2 - actually still level 1
		case 2: 
			//Flip flops
			objects.push_back( new Flip(-15.25f, 15.0f, -1.875f, false, objects.size()+10) );
			objects.push_back( new Flip(-1.75f, 15.0f, -1.875f, false, objects.size()+10) );
			objects.push_back( new Flip(11.75f, 15.0f, -1.875f, false, objects.size()+10) );
			objects.push_back( new Flip(24.0f, 15.0f, -1.875f, false, objects.size()+10) );
			objects.push_back( new Flip(9.0f, -0.75f, -1.875f, false, objects.size()+10) );
			objects.push_back( new Flip(-20.0f, -8.5f, -1.875f, false, objects.size()+10) );
			objects.push_back( new Flip(-18.5f, 11.0f, -1.875f, false, objects.size()+10) );

			//Balls
			objects.push_back( new Ball(-18.75f, 18.25f, -2.0f, Vec3(1, .5f, .5f), objects.size()+10, &objects) );
			objects.push_back( new Ball(-5.0f, 17.75f, -2.0f, Vec3(1, .25f, .25f), objects.size()+10, &objects) );
			objects.push_back( new Ball(7.25, 17.75f, -2.0f, Vec3(.25f, 1, .25f), objects.size()+10, &objects) );
			objects.push_back( new Ball(19.5f, 17.75f, -2.0f, Vec3(.25f, .25f, 1), objects.size()+10, &objects) );

			//Jump pads
			objects.push_back( new JumpPad(24.375f, -2.125f, -1.875f, objects.size()+10) );
			objects.push_back( new JumpPad(-10.625f, -8.125f, -1.875f, objects.size()+10) );
			objects.push_back( new JumpPad(24.375f, -10.875f, -1.875f, objects.size()+10) );

			//Teleports
			objects.push_back( new Teleport(-10.625f, -11.375f, -1.875f, objects.size()+10, 2.375f, 9.125f) );

			//Score points
			objects.push_back( new Score(-8.375f, -3.125f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(-21.375f, 12.875f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(15.625f, -2.875f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(24.375f, 6.625f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(24.125f, -4.625f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(0.625f, 5.875f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(-12.625f, 5.875f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(-6.875f, -12.625f, -1.875f, objects.size()+10) );
			objects.push_back( new Score(3.625f, -3.125f, -1.875f, objects.size()+10) );
		break;
	}
}

void Level::Update(){
	//cout << "Level update" << endl;
	for (int i = 0; i < objects.size(); i++){
		//objects.at(i)->GetModel()->UpdatePhysics();

		//Ball?
		if (objects.at(i)->GetObjectType() == 2){
			objects.at(i)->Update();
			objects.at(i)->GetModel()->AddForce(0,-2*Time::GetSpeed(),0,true);
			//objects.at(i)->GetModel()->UpdateAABB();
		}
	}
}

void Level::DestructLevel(){
	//Remove every level piece.

	cout << "removing" << endl;
	while(!objects.empty()) delete objects.back(), objects.pop_back();
	cout << "Removed. Vector size: " << objects.size() << endl;
}