#include "MainMenu.h"

MainMenu::MainMenu(Window* window, Context* context){
	this->window = window;
	this->context = context;

	logo = Texture::Load("Materials/Logo.tex");
	howToPlay = Texture::Load("Materials/HowToPlay.tex");
	levelsText = Texture::Load("Materials/SelectALevel.tex");

	levels.push_back( Texture::Load("Materials/Level1.tex") );
	levels.push_back( Texture::Load("Materials/Level1.tex") );

	SetLoadLevel(-1);
}

MainMenu::~MainMenu(){
	window = NULL;
	context = NULL;
	logo->Release();
	howToPlay->Release();
	levelsText->Release();
}

void MainMenu::Draw(){
	bool mouseOver = true;

	//Draw logo
	logo->Draw(window->GetWidth()/4 - logo->GetWidth()/4, 20, logo->GetWidth()/2, logo->GetHeight()/2);

	//If the mouse is not inside of the image
	if (!(window->MouseX() > 20 && window->MouseX() < (20+window->GetWidth()/2)
		&& window->MouseY() > window->GetHeight()*.35f && window->MouseY() < (window->GetHeight()*.35f+window->GetHeight()/1.5f)))
	{
		//Then set the image alpha transparant
		context->SetColor(1,1,1,.25f);
	}
	//Now draw the image with its transparancy if needed
	howToPlay->Draw(20, window->GetHeight()*.35f, window->GetWidth()/2, window->GetHeight()/1.5f);

	//Reset color for next images
	context->SetColor(1,1,1,1);

	//If the mouse is not inside of the image
	if (!(window->MouseX() > window->GetWidth()/2+20 && window->MouseX() < window->GetWidth()
		&& window->MouseY() > window->GetHeight()*.25f && window->MouseY() < (window->GetHeight()*.25f+window->GetHeight()/1.5f)))
	{
		//Then set the image alpha transparant
		context->SetColor(1,1,1,.25f);
		mouseOver = false;
	}
	//Now draw the image with its transparancy if needed
	levelsText->Draw(window->GetWidth()/2+20, window->GetHeight()*.25f, window->GetWidth()/2, window->GetHeight()/1.5f);

	//Draw level images
	for (int i = 0; i < levels.size(); i++){
		//Set default transparancy
		context->SetColor(1,1,1, mouseOver ? .425f : .25f);

		//Mouse over this level?
		if (window->MouseX() > window->GetWidth()/2+20 && window->MouseX() < window->GetWidth()
		&& window->MouseY() > window->GetHeight()*(.35f+(.2f*i)) && window->MouseY() < window->GetHeight()*(.35f+(.2f*(i+1))))
		{
			context->SetColor(1,1,1,1);

			if (window->MouseHit(1)){
				//cout << "WE SHOULD BE LOADING A LEVEL HERE. ID: " << i << endl;
				SetLoadLevel(i+1);
			}
		}

		//Draw image
		levels.at(i)->Draw(window->GetWidth()/2+20, window->GetHeight()*(.35f+(.2f*i)), window->GetWidth()/2, window->GetHeight()/1.5f);
	}

	//Reset color for next images in other classes
	context->SetColor(1,1,1,1);
}