#include "MenuManager.h"

MenuManager::MenuManager(Window* window, Context* context, World* world, Level* level, HUD* hud){
	this->window = window;
	this->context = context;
	this->world = world;
	this->level = level;
	this->hud = hud;
	recreateCam = false;

	stage = -1; //-1: Splash. 0: Menu. 1 and above: Levels
}

MenuManager::~MenuManager(){
	window = NULL;
	delete splash;
}

void MenuManager::LoadSplash(){
	splash = new SplashScreen(window, context);
}

void MenuManager::LoadMainScreen(bool returnFromIngame){
	stage = 0;
	mainMenu = new MainMenu(window, context);
	hud->SetIngame(false);

	if (!returnFromIngame) return;

	cout << "clearing" << endl;
	world->Clear();
	level->DestructLevel();
	cout << "creating" << endl;
	world = World::Create();

	cout << "loading map" << endl;
	string mapname = System::GetProperty("map","Maps/menu.map"); //"Maps/level1.map"
	Map::Load(mapname);

	level->CreateLevel(0);

	stage = 0;
	World::SetCurrent(world);
	SetRecreateCam(true);
	cout << "done" << endl;
}

void MenuManager::Draw(){
	switch(stage){
		//Splash
		case -1:
			splash->Draw();

			if (window->KeyHit(Key::Space)){
				LoadMainScreen(false);
			}
		break;
	
		//Menu
		case 0:
			mainMenu->Draw();

			if (mainMenu->GetLoadLevel() != -1){
				cout << "clearing" << endl;
				//world->Clear();
				//world->
				world->Clear();
				level->DestructLevel();
				cout << "creating" << endl;
				//world->Create();
				world = World::Create();

				cout << "loading map" << endl;
				//stringstream leveltoload;
				//leveltoload << "Maps/level" << 1 << ".map";
				string mapname = System::GetProperty("map","Maps/level1.map"); //"Maps/level1.map"
				Map::Load(mapname);

				level->CreateLevel(mainMenu->GetLoadLevel());

				stage = mainMenu->GetLoadLevel();
				World::SetCurrent(world);
				delete mainMenu;
				SetRecreateCam(true);
				hud->SetIngame(true);
				cout << "done" << endl;
			}
		break;

		//Levels
		default:
			if (window->KeyHit(Key::Escape)){
				LoadMainScreen(true);
			}
		break;
	}
}