#pragma once

#include "Leadwerks.h"
#include "MainMenu.h"
#include "SplashScreen.h"
#include "Level.h"
#include "HUD.h"

using namespace Leadwerks;

class MenuManager{
private:
	Window* window; //To get mouse and keyboard input
	Context* context; //To control the rendering of the images such as alpha.
	World* world; //To load a new map
	Camera* camera;
	HUD* hud;

	Level* level; //Needed to load a new map (void DestructLevel())

	SplashScreen* splash;
	MainMenu* mainMenu;

	int stage;
	bool recreateCam;

public:
	MenuManager(Window* window, Context* context, World* world, Level* level, HUD* hud);
	~MenuManager();

	void LoadSplash();
	void LoadMainScreen(bool returnFromIngame);

	void Draw();

	bool GetRecreateCam(){ return recreateCam; }
	void SetRecreateCam(bool val){ recreateCam = val; }
};