#include "SplashScreen.h"

SplashScreen::SplashScreen(Window* window, Context* context){
	this->window = window;
	this->context = context;
	logo = Texture::Load("Materials/Logo.tex");
	pressSpace = Texture::Load("Materials/PressSpace.tex");

	splashAlpha = 1;
	alphaUp = false; //False: Go to 0. True: Go to 1.
}

SplashScreen::~SplashScreen(void){
	window = NULL;
}

void SplashScreen::Draw(){
	logo->Draw(window->GetWidth()/2 - logo->GetWidth()/2, 20);

	context->SetColor(1,1,1,splashAlpha);
	pressSpace->Draw(window->GetWidth()/2 - pressSpace->GetWidth()/2, window->GetHeight()*.95f - pressSpace->GetHeight());
	context->SetColor(1,1,1,1);

	//Change Alpha
	if (alphaUp){
		splashAlpha += .015f*Time::GetSpeed();

		if (splashAlpha >= 1){
			splashAlpha = 1;
			alphaUp = false;
		}
	}

	else{
		splashAlpha -= .015f*Time::GetSpeed();

		if (splashAlpha <= 0){
			splashAlpha = 0;
			alphaUp = true;
		}
	}
}